<?
 class calendar_backend extends BasePluginBackend
 {
  function output($args)
  {
   global $_path;

   $output="";

   if($args[0]!="main") //only display main
    return $output;

   require_once($this->plugin->path["root"]."timeline.php");

   $output.="Timeline: ";
   $output.="<a href=\"".$this->plugin->url()."test=timelineDefault\">Default test</a>";
   $output.="<br/>";

   $output.="Grid: ";
   $output.="<a href=\"".$this->plugin->url()."test=gridDefault\">Default test</a>";
   $output.="<br/>";

   $output.="<br/>";
   if(request("test")=="timelineDefault")
    $output.=$this->timelineDefaultTest();
   else if(request("test")=="gridDefault")
    $output.=$this->gridDefaultTest();
   else
    $output.=$this->timelineDefaultTest();

   return $output;
  }

  function timelineDefaultTest()
  {
   $tl=new Timeline("G:i");
   $r=$tl->style();

   $tl->event("Meeting room #1", "Project meeting", "9:00", "10:00", false, "pm");
   $tl->event("Meeting room #1", "Lunch meeting", "12:00", "12:15", false, "lm");
   $tl->event("Meeting room #1", "Board meeting", "13:00", "15:00", "No maintenance!", "bm");
   $tl->event("Meeting room #1", "Maintenance", "8:00", "18:00", false, "m");

   $tl->event("Meeting room #2", "Project meeting", "11:30", "15:45", false, "pm");
   $tl->event("Meeting room #2", "Maintenance", "8:00", "18:00", "m");

   $r.=$tl->render("7:00", "19:00", 15*60, 60*60)."<br/><br/>";
   $r.=$tl->render("7:00", "19:00", 15*60, 60*60, "vertical")."<br/><br/>";


   $tl=new Timeline("d-m-Y");

   $tl->event("Deliverable 1", "Design", "01-08-2011", "06-08-2011");
   $tl->event("Deliverable 1", "Build", "08-08-2011", "22-08-2011");
   $tl->event("Deliverable 1", "FAT", "22-08-2011", "27-08-2011");
   $tl->event("Deliverable 1", "UAT", "29-08-2011", "31-08-2011");
   $tl->event("Deliverable 1", "Test prepartion", "08-08-2011", "22-08-2011");

   $r.=$tl->render(false, false, 86400, 86400*7, "horizontal", "\\W\\e\\e\\k #W")."<br/><br/>";

   return $r;
  }

  function gridDefaultTest()
  {
   $tl=new Timeline();
   $r=$tl->style(); //get styling from timeline

   $grid=new Grid("timeline"); //use timeline class


   $grid->clear();

   $grid->setSection("header");
   $grid->setEntry("0:00", 6);
   $grid->setEntry("1:00", 6);
   $grid->setEntry("2:00", 6);
   $grid->setEntry("3:00", 6);
   $grid->setEntry("4:00", 6);
   $grid->setEntry("5:00", 6);

   $grid->setSection();
   $grid->setEntry("Half way",  9,  12);
   $grid->setEntry("Last hour", 30, 36);
   $grid->setTooltip("Test 1");

   $grid->setSection();
   $grid->setEntry("First hour", 0,  6);
   $grid->setTooltip("Test 2");
   $grid->setEntry("Half way",   12, 30);

   $grid->setSection();
   $grid->setEntry("Half way",  9,  12);
   $grid->setTooltip("Test 3");
   $grid->setEntry("Last hour", 30, 36);
   $grid->setTooltip("Test 4");

   $r.=$grid->render()."<br/><br/>";
   $r.=$grid->render("vertical")."<br/><br/>";


   $grid->clear();

   $grid->setSection("header");
   $grid->setEntry("0", 100);
   $grid->setEntry("100", 100);
   $grid->setEntry("200", 100);
   $grid->setEntry("300", 100);
   $grid->setEntry("400", 100);

   $grid->setSection();
   $grid->setEntry("Test 1", 0,  115);
   $grid->setTooltip("Test 1");
   $grid->setEntry("Test 2", 150, 190);
   $grid->setTooltip("Test 2");
   $grid->setEntry("Test 3", 200, 300);
   $grid->setTooltip("Test 3");
   $grid->setEntry("Test 4", 230, 350);
   $grid->setTooltip("Test 4");
   $grid->setEntry("Test 5", 50, 350);
   $grid->setTooltip("Test 5");

   $r.=$grid->render("horizontal", 25)."<br/><br/>";
   $r.=$grid->render("vertical", 25)."<br/><br/>";


   $grid->clear();

   $grid->setSection("header");
   $grid->setEntry("1", 1);
   $grid->setEntry("2", 1);
   $grid->setEntry("3", 1);
   $grid->setEntry("4", 1);
   $grid->setEntry("5", 1);

   $grid->setSection();
   $grid->setBefore("First");
   $grid->setAfter("Last");
   $grid->setEntry("Test 1", 0, 2);
   $grid->setEntry("Test 2", 3, 4);
   $grid->setEntry("Test 2", 1, 3);
   $grid->setEntry("Test 3", 0, 3);

   $grid->setSection();
   $grid->setBefore("First");
   $grid->setAfter("Last");
   $grid->setEntry("Test 1", 0, 2);
   $grid->setEntry("Test 2", 3, 4);
   $grid->setEntry("Test 3", 0, 5);

   $grid->setSection("footer");
   $grid->setEntry("1", 1);
   $grid->setEntry("2", 1);
   $grid->setEntry("3", 1);
   $grid->setEntry("4", 1);
   $grid->setEntry("5", 1);


   $r.=$grid->render("horizontal")."<br/><br/>";
   $r.=$grid->render("vertical")."<br/><br/>";


   return $r;
  }
 }

?>
